"use strict";

exports.__esModule = true;
exports.default = _default;

var _pluginSyntaxNullishCoalescingOperator = _interopRequireDefault(require("@babel/plugin-syntax-nullish-coalescing-operator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default(_ref, _ref2) {
  var t = _ref.types;
  var _ref2$loose = _ref2.loose,
      loose = _ref2$loose === void 0 ? false : _ref2$loose;
  return {
    inherits: _pluginSyntaxNullishCoalescingOperator.default,
    visitor: {
      LogicalExpression: function LogicalExpression(path) {
        var node = path.node,
            scope = path.scope;

        if (node.operator !== "??") {
          return;
        }

        var ref = scope.generateUidIdentifierBasedOnNode(node.left);
        scope.push({
          id: ref
        });
        var assignment = t.assignmentExpression("=", t.clone(ref), node.left);
        path.replaceWith(t.conditionalExpression(loose ? t.binaryExpression("!=", assignment, t.nullLiteral()) : t.logicalExpression("&&", t.binaryExpression("!==", assignment, t.nullLiteral()), t.binaryExpression("!==", t.clone(ref), scope.buildUndefinedNode())), t.clone(ref), node.right));
      }
    }
  };
}